//
//  AgoroKit.h
//  TXCopyrightedMediaDemo_Agora
//
//  Created by Zhirui Ou on 2022/2/25.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface AgoraAudioFrame : NSObject
/** The number of samples per channel.
*/
@property(assign, nonatomic) NSInteger samplesPerChannel;
/** The number of bytes per audio sample. For example, each PCM audio sample
usually takes up 16 bits (2 bytes).
*/
@property(assign, nonatomic) NSInteger bytesPerSample;
/** The number of audio channels. If the channel uses stereo, the data is
interleaved.

- 1: Mono.
- 2: Stereo.
*/
@property(assign, nonatomic) NSInteger channels;
/** The sample rate.
*/
@property(assign, nonatomic) NSInteger samplesPerSec;
/** The buffer of the sample audio data. When the audio frame uses a stereo
channel, the data buffer is interleaved. The size of the data buffer is as
follows: `buffer` = `samplesPerChannel` × `channels` × `bytesPerSample`.
*/
@property(assign, nonatomic) void* _Nullable buffer;
/** The timestamp of the external audio frame. You can use this parameter for
the following purposes:

- Restore the order of the captured audio frame.
- Synchronize audio and video frames in video-related scenarios, including
where external video sources are used.
*/
@property(assign, nonatomic) int64_t renderTimeMs;
/** Reserved for future use.
*/
@property(assign, nonatomic) NSInteger avSyncType;
@end




@interface AgoraRtcEngineKit : NSObject

- (int)pushExternalAudioFrameRawData:(int)sourcePos frame:(AgoraAudioFrame* _Nonnull)frame;

@end

NS_ASSUME_NONNULL_END
