//
//  PcmPlayer.h
//  TXCopyrightedMediaDemo
//
//  Created by chavezchen on 2022/6/15.
//

#import <Foundation/Foundation.h>
#import <AudioToolbox/AudioToolbox.h>

NS_ASSUME_NONNULL_BEGIN

@protocol pcmPlayerDelegate <NSObject>

// 播放完一帧数据
- (void)pcmPlayerPlayedFrameData;

// seek
- (void)pcmPlayerSeeked:(int)pts;

// 播放时长回调
- (void)pcmPlayerPlayedTime:(float)time;

@end

static int const kBufferSize = 3; // 队列缓冲个数

@interface PcmPlayer : NSObject

@property (nonatomic, weak) id<pcmPlayerDelegate> delegate;
@property (nonatomic, assign) float playedTime; // 已经播放的时长

- (instancetype)initWithSampleRate:(NSInteger)sampleRate
                  channelsPerFrame:(int)channelsPerFrame
                    bitsPerChannel:(int)bitsPerChannel;

- (void)play;

- (void)pause;

- (void)stop;

- (void)seek:(int)pts;

// 调用play之前，需要先push kBufferSize帧数据（pcm没有帧的概念，可以理解为push三段data,kBufferSize = 3）
- (void)pushData:(NSData *)data;


@end

NS_ASSUME_NONNULL_END
