//
//  ZegoExpressKit.m
//  TXCopyrightedMediaDemo
//
//  Created by Zhirui Ou on 2021/12/27.
//

#import "ZegoExpressKit.h"

@implementation ZegoExpressKit

- (void)setAudioMixingHandler:(id)handler
{
    self.mixingHandler = handler;
}

- (dispatch_source_t)timer
{
    if (!_timer) {
        char *captureFileName = [[NSString stringWithFormat:@"12345.pcm"] cStringUsingEncoding:NSUTF8StringEncoding];
        NSString* systemDocumentPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) firstObject];
        NSString* filePath = [NSString stringWithFormat:@"%@/%s", systemDocumentPath, captureFileName];
        NSLog(@"filePath = %@", filePath);
        FILE *captureAudioDumpFile = fopen([filePath UTF8String], "wb");
        
        _timer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0,dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0));
        double count  = 1024./32000.;
        uint64_t interval = (uint64_t)(count * NSEC_PER_SEC);
        dispatch_source_set_timer(_timer, DISPATCH_TIME_NOW, interval, 0);
        __weak typeof(self) weakSelf = self;
        __block unsigned long long size = 0;
        dispatch_source_set_event_handler(_timer, ^{
            dispatch_async(dispatch_get_main_queue(), ^{
                __strong typeof(weakSelf) strongSelf = weakSelf;
                SEL selector = @selector(onAudioMixingCopyData:);
                IMP imp = [strongSelf.mixingHandler methodForSelector:selector];
                id (*func)(id, SEL, NSInteger) = (void *)imp;
                id ret = func(strongSelf.mixingHandler, selector, 5000);
                if ([ret isKindOfClass:NSData.class]) {
                    NSData *data = (NSData *)ret;
                    size = size + data.length;
                    fwrite(data.bytes, 1, data.length, captureAudioDumpFile);
                }else {
                    
                    fclose(captureAudioDumpFile);
                }
            });
            
            
        });
    }
    return _timer;
}

@end
