//
//  ZegoLiveRoomKit.m
//  TXCopyrightedMediaDemo_ZL
//
//  Created by Zhirui Ou on 2022/3/1.
//

#import "ZegoLiveRoomKit.h"

@implementation ZegoLiveRoomKit

@end

@interface ZegoAudioAux ()

@property (nonatomic, strong) id<ZegoAudioAuxDelgate> mDelegate;
@property (nonatomic, weak) NSTimer *timer;

@end

@implementation ZegoAudioAux

- (instancetype)init
{
    if (self = [super init]) {
        self.timer = [NSTimer scheduledTimerWithTimeInterval:0.000032 repeats:YES block:^(NSTimer * _Nonnull timer) {
            if ([self.mDelegate respondsToSelector:@selector(onAuxCallback:dataLen:sampleRate:channelCount:)]) {
//                - (void)onAuxCallback:(void *)pData dataLen:(int *)pDataLen sampleRate:(int *)pSampleRate channelCount:(int *)pChannelCount;
                int pDataLen = 4096;
                void* pData = malloc(pDataLen * sizeof(char));
                int pSampleRate = 0;
                int pChannelCount = 0;
                [self.mDelegate onAuxCallback:pData dataLen:&pDataLen sampleRate:&pSampleRate channelCount:&pChannelCount];
                NSLog(@"pDataLen = %@, pSampleRate = %@, pChannelCount = %@", @(pDataLen), @(pSampleRate), @(pChannelCount));
                if (pDataLen == 0) {
                    [timer invalidate];
                }
            }
        }];
    }
    
    return self;
}

- (void)setDelegate:(id<ZegoAudioAuxDelgate>) delegate
{
    self.mDelegate = delegate;
}

- (void)destory
{
    [self.timer invalidate];
    self.timer = nil;
    self.mDelegate = nil;
}

@end
